// pub fn get_flag_emoji(country_code: &str) -> String {
//     let mut flag = String::new();

//     for c in country_code.trim().to_uppercase().chars() {
//         if let Some(c) = std::char::from_u32(c as u32 + 127397) {
//             flag.push(c);
//         } else {
//             panic!("could not convert country code \"{}\" to flag emoji", country_code)
//         }
//     }

//     flag
// }

pub enum CountryCode {
    Unknown,
    AX,
    AL,
    AF,
    DZ,
    AS,
    AD,
    AO,
    AI,
    AQ,
    AG,
    AR,
    AM,
    AW,
    AU,
    AT,
    AZ,
    BS,
    BH,
    BD,
    BB,
    BY,
    BE,
    BZ,
    BJ,
    BM,
    BT,
    BO,
    BQ,
    BA,
    BW,
    BV,
    BR,
    IO,
    BN,
    BG,
    BF,
    BI,
    CV,
    KH,
    CM,
    CA,
    KY,
    CF,
    TD,
    CL,
    CN,
    CX,
    CC,
    CO,
    KM,
    CG,
    CD,
    CK,
    CR,
    CI,
    HR,
    CU,
    CW,
    CY,
    CZ,
    DK,
    DJ,
    DM,
    DO,
    EC,
    EG,
    SV,
    GQ,
    ER,
    EE,
    ET,
    FK,
    FO,
    FJ,
    FI,
    FR,
    GF,
    PF,
    TF,
    GA,
    GM,
    GE,
    DE,
    GH,
    GI,
    GR,
    GL,
    GD,
    GP,
    GU,
    GT,
    GG,
    GN,
    GW,
    GY,
    HT,
    HM,
    VA,
    HN,
    HK,
    HU,
    IS,
    IN,
    ID,
    IR,
    IQ,
    IE,
    IM,
    IL,
    IT,
    JM,
    JP,
    JE,
    JO,
    KZ,
    KE,
    KI,
    KP,
    KR,
    KW,
    KG,
    LA,
    LV,
    LB,
    LS,
    LR,
    LY,
    LI,
    LT,
    LU,
    MO,
    MK,
    MG,
    MW,
    MY,
    MV,
    ML,
    MT,
    MH,
    MQ,
    MR,
    MU,
    YT,
    MX,
    FM,
    MD,
    MC,
    MN,
    ME,
    MS,
    MA,
    MZ,
    MM,
    NA,
    NR,
    NP,
    NL,
    NC,
    NZ,
    NI,
    NE,
    NG,
    NU,
    NF,
    MP,
    NO,
    OM,
    PK,
    PW,
    PS,
    PA,
    PG,
    PY,
    PE,
    PH,
    PN,
    PL,
    PT,
    PR,
    QA,
    RE,
    RO,
    RU,
    RW,
    BL,
    SH,
    KN,
    LC,
    MF,
    PM,
    VC,
    WS,
    SM,
    ST,
    SA,
    SN,
    RS,
    SC,
    SL,
    SG,
    SX,
    SK,
    SI,
    SB,
    SO,
    ZA,
    GS,
    SS,
    ES,
    LK,
    SD,
    SR,
    SJ,
    SZ,
    SE,
    CH,
    SY,
    TW,
    TJ,
    TZ,
    TH,
    TL,
    TG,
    TK,
    TO,
    TT,
    TN,
    TR,
    TM,
    TC,
    TV,
    UG,
    UA,
    AE,
    GB,
    US,
    UM,
    UY,
    UZ,
    VU,
    VE,
    VN,
    VG,
    VI,
    WF,
    EH,
    YE,
    ZM,
    ZW,
}

impl From<CountryCode> for &str {
    fn from(cc: CountryCode) -> Self {
        match cc {
            CountryCode::AX => "AX",
            CountryCode::AL => "AL",
            CountryCode::AF => "AF",
            CountryCode::DZ => "DZ",
            CountryCode::AS => "AS",
            CountryCode::AD => "AD",
            CountryCode::AO => "AO",
            CountryCode::AI => "AI",
            CountryCode::AQ => "AQ",
            CountryCode::AG => "AG",
            CountryCode::AR => "AR",
            CountryCode::AM => "AM",
            CountryCode::AW => "AW",
            CountryCode::AU => "AU",
            CountryCode::AT => "AT",
            CountryCode::AZ => "AZ",
            CountryCode::BS => "BS",
            CountryCode::BH => "BH",
            CountryCode::BD => "BD",
            CountryCode::BB => "BB",
            CountryCode::BY => "BY",
            CountryCode::BE => "BE",
            CountryCode::BZ => "BZ",
            CountryCode::BJ => "BJ",
            CountryCode::BM => "BM",
            CountryCode::BT => "BT",
            CountryCode::BO => "BO",
            CountryCode::BQ => "BQ",
            CountryCode::BA => "BA",
            CountryCode::BW => "BW",
            CountryCode::BV => "BV",
            CountryCode::BR => "BR",
            CountryCode::IO => "IO",
            CountryCode::BN => "BN",
            CountryCode::BG => "BG",
            CountryCode::BF => "BF",
            CountryCode::BI => "BI",
            CountryCode::CV => "CV",
            CountryCode::KH => "KH",
            CountryCode::CM => "CM",
            CountryCode::CA => "CA",
            CountryCode::KY => "KY",
            CountryCode::CF => "CF",
            CountryCode::TD => "TD",
            CountryCode::CL => "CL",
            CountryCode::CN => "CN",
            CountryCode::CX => "CX",
            CountryCode::CC => "CC",
            CountryCode::CO => "CO",
            CountryCode::KM => "KM",
            CountryCode::CG => "CG",
            CountryCode::CD => "CD",
            CountryCode::CK => "CK",
            CountryCode::CR => "CR",
            CountryCode::CI => "CI",
            CountryCode::HR => "HR",
            CountryCode::CU => "CU",
            CountryCode::CW => "CW",
            CountryCode::CY => "CY",
            CountryCode::CZ => "CZ",
            CountryCode::DK => "DK",
            CountryCode::DJ => "DJ",
            CountryCode::DM => "DM",
            CountryCode::DO => "DO",
            CountryCode::EC => "EC",
            CountryCode::EG => "EG",
            CountryCode::SV => "SV",
            CountryCode::GQ => "GQ",
            CountryCode::ER => "ER",
            CountryCode::EE => "EE",
            CountryCode::ET => "ET",
            CountryCode::FK => "FK",
            CountryCode::FO => "FO",
            CountryCode::FJ => "FJ",
            CountryCode::FI => "FI",
            CountryCode::FR => "FR",
            CountryCode::GF => "GF",
            CountryCode::PF => "PF",
            CountryCode::TF => "TF",
            CountryCode::GA => "GA",
            CountryCode::GM => "GM",
            CountryCode::GE => "GE",
            CountryCode::DE => "DE",
            CountryCode::GH => "GH",
            CountryCode::GI => "GI",
            CountryCode::GR => "GR",
            CountryCode::GL => "GL",
            CountryCode::GD => "GD",
            CountryCode::GP => "GP",
            CountryCode::GU => "GU",
            CountryCode::GT => "GT",
            CountryCode::GG => "GG",
            CountryCode::GN => "GN",
            CountryCode::GW => "GW",
            CountryCode::GY => "GY",
            CountryCode::HT => "HT",
            CountryCode::HM => "HM",
            CountryCode::VA => "VA",
            CountryCode::HN => "HN",
            CountryCode::HK => "HK",
            CountryCode::HU => "HU",
            CountryCode::IS => "IS",
            CountryCode::IN => "IN",
            CountryCode::ID => "ID",
            CountryCode::IR => "IR",
            CountryCode::IQ => "IQ",
            CountryCode::IE => "IE",
            CountryCode::IM => "IM",
            CountryCode::IL => "IL",
            CountryCode::IT => "IT",
            CountryCode::JM => "JM",
            CountryCode::JP => "JP",
            CountryCode::JE => "JE",
            CountryCode::JO => "JO",
            CountryCode::KZ => "KZ",
            CountryCode::KE => "KE",
            CountryCode::KI => "KI",
            CountryCode::KP => "KP",
            CountryCode::KR => "KR",
            CountryCode::KW => "KW",
            CountryCode::KG => "KG",
            CountryCode::LA => "LA",
            CountryCode::LV => "LV",
            CountryCode::LB => "LB",
            CountryCode::LS => "LS",
            CountryCode::LR => "LR",
            CountryCode::LY => "LY",
            CountryCode::LI => "LI",
            CountryCode::LT => "LT",
            CountryCode::LU => "LU",
            CountryCode::MO => "MO",
            CountryCode::MK => "MK",
            CountryCode::MG => "MG",
            CountryCode::MW => "MW",
            CountryCode::MY => "MY",
            CountryCode::MV => "MV",
            CountryCode::ML => "ML",
            CountryCode::MT => "MT",
            CountryCode::MH => "MH",
            CountryCode::MQ => "MQ",
            CountryCode::MR => "MR",
            CountryCode::MU => "MU",
            CountryCode::YT => "YT",
            CountryCode::MX => "MX",
            CountryCode::FM => "FM",
            CountryCode::MD => "MD",
            CountryCode::MC => "MC",
            CountryCode::MN => "MN",
            CountryCode::ME => "ME",
            CountryCode::MS => "MS",
            CountryCode::MA => "MA",
            CountryCode::MZ => "MZ",
            CountryCode::MM => "MM",
            CountryCode::NA => "NA",
            CountryCode::NR => "NR",
            CountryCode::NP => "NP",
            CountryCode::NL => "NL",
            CountryCode::NC => "NC",
            CountryCode::NZ => "NZ",
            CountryCode::NI => "NI",
            CountryCode::NE => "NE",
            CountryCode::NG => "NG",
            CountryCode::NU => "NU",
            CountryCode::NF => "NF",
            CountryCode::MP => "MP",
            CountryCode::NO => "NO",
            CountryCode::OM => "OM",
            CountryCode::PK => "PK",
            CountryCode::PW => "PW",
            CountryCode::PS => "PS",
            CountryCode::PA => "PA",
            CountryCode::PG => "PG",
            CountryCode::PY => "PY",
            CountryCode::PE => "PE",
            CountryCode::PH => "PH",
            CountryCode::PN => "PN",
            CountryCode::PL => "PL",
            CountryCode::PT => "PT",
            CountryCode::PR => "PR",
            CountryCode::QA => "QA",
            CountryCode::RE => "RE",
            CountryCode::RO => "RO",
            CountryCode::RU => "RU",
            CountryCode::RW => "RW",
            CountryCode::BL => "BL",
            CountryCode::SH => "SH",
            CountryCode::KN => "KN",
            CountryCode::LC => "LC",
            CountryCode::MF => "MF",
            CountryCode::PM => "PM",
            CountryCode::VC => "VC",
            CountryCode::WS => "WS",
            CountryCode::SM => "SM",
            CountryCode::ST => "ST",
            CountryCode::SA => "SA",
            CountryCode::SN => "SN",
            CountryCode::RS => "RS",
            CountryCode::SC => "SC",
            CountryCode::SL => "SL",
            CountryCode::SG => "SG",
            CountryCode::SX => "SX",
            CountryCode::SK => "SK",
            CountryCode::SI => "SI",
            CountryCode::SB => "SB",
            CountryCode::SO => "SO",
            CountryCode::ZA => "ZA",
            CountryCode::GS => "GS",
            CountryCode::SS => "SS",
            CountryCode::ES => "ES",
            CountryCode::LK => "LK",
            CountryCode::SD => "SD",
            CountryCode::SR => "SR",
            CountryCode::SJ => "SJ",
            CountryCode::SZ => "SZ",
            CountryCode::SE => "SE",
            CountryCode::CH => "CH",
            CountryCode::SY => "SY",
            CountryCode::TW => "TW",
            CountryCode::TJ => "TJ",
            CountryCode::TZ => "TZ",
            CountryCode::TH => "TH",
            CountryCode::TL => "TL",
            CountryCode::TG => "TG",
            CountryCode::TK => "TK",
            CountryCode::TO => "TO",
            CountryCode::TT => "TT",
            CountryCode::TN => "TN",
            CountryCode::TR => "TR",
            CountryCode::TM => "TM",
            CountryCode::TC => "TC",
            CountryCode::TV => "TV",
            CountryCode::UG => "UG",
            CountryCode::UA => "UA",
            CountryCode::AE => "AE",
            CountryCode::GB => "GB",
            CountryCode::US => "US",
            CountryCode::UM => "UM",
            CountryCode::UY => "UY",
            CountryCode::UZ => "UZ",
            CountryCode::VU => "VU",
            CountryCode::VE => "VE",
            CountryCode::VN => "VN",
            CountryCode::VG => "VG",
            CountryCode::VI => "VI",
            CountryCode::WF => "WF",
            CountryCode::EH => "EH",
            CountryCode::YE => "YE",
            CountryCode::ZM => "ZM",
            CountryCode::ZW => "ZW",
            CountryCode::Unknown => "Unknown",
        }
    }
}

impl From<&str> for CountryCode {
    fn from(s: &str) -> Self {
        match s {
            "AX" => CountryCode::AX,
            "AL" => CountryCode::AL,
            "AF" => CountryCode::AF,
            "DZ" => CountryCode::DZ,
            "AS" => CountryCode::AS,
            "AD" => CountryCode::AD,
            "AO" => CountryCode::AO,
            "AI" => CountryCode::AI,
            "AQ" => CountryCode::AQ,
            "AG" => CountryCode::AG,
            "AR" => CountryCode::AR,
            "AM" => CountryCode::AM,
            "AW" => CountryCode::AW,
            "AU" => CountryCode::AU,
            "AT" => CountryCode::AT,
            "AZ" => CountryCode::AZ,
            "BS" => CountryCode::BS,
            "BH" => CountryCode::BH,
            "BD" => CountryCode::BD,
            "BB" => CountryCode::BB,
            "BY" => CountryCode::BY,
            "BE" => CountryCode::BE,
            "BZ" => CountryCode::BZ,
            "BJ" => CountryCode::BJ,
            "BM" => CountryCode::BM,
            "BT" => CountryCode::BT,
            "BO" => CountryCode::BO,
            "BQ" => CountryCode::BQ,
            "BA" => CountryCode::BA,
            "BW" => CountryCode::BW,
            "BV" => CountryCode::BV,
            "BR" => CountryCode::BR,
            "IO" => CountryCode::IO,
            "BN" => CountryCode::BN,
            "BG" => CountryCode::BG,
            "BF" => CountryCode::BF,
            "BI" => CountryCode::BI,
            "CV" => CountryCode::CV,
            "KH" => CountryCode::KH,
            "CM" => CountryCode::CM,
            "CA" => CountryCode::CA,
            "KY" => CountryCode::KY,
            "CF" => CountryCode::CF,
            "TD" => CountryCode::TD,
            "CL" => CountryCode::CL,
            "CN" => CountryCode::CN,
            "CX" => CountryCode::CX,
            "CC" => CountryCode::CC,
            "CO" => CountryCode::CO,
            "KM" => CountryCode::KM,
            "CG" => CountryCode::CG,
            "CD" => CountryCode::CD,
            "CK" => CountryCode::CK,
            "CR" => CountryCode::CR,
            "CI" => CountryCode::CI,
            "HR" => CountryCode::HR,
            "CU" => CountryCode::CU,
            "CW" => CountryCode::CW,
            "CY" => CountryCode::CY,
            "CZ" => CountryCode::CZ,
            "DK" => CountryCode::DK,
            "DJ" => CountryCode::DJ,
            "DM" => CountryCode::DM,
            "DO" => CountryCode::DO,
            "EC" => CountryCode::EC,
            "EG" => CountryCode::EG,
            "SV" => CountryCode::SV,
            "GQ" => CountryCode::GQ,
            "ER" => CountryCode::ER,
            "EE" => CountryCode::EE,
            "ET" => CountryCode::ET,
            "FK" => CountryCode::FK,
            "FO" => CountryCode::FO,
            "FJ" => CountryCode::FJ,
            "FI" => CountryCode::FI,
            "FR" => CountryCode::FR,
            "GF" => CountryCode::GF,
            "PF" => CountryCode::PF,
            "TF" => CountryCode::TF,
            "GA" => CountryCode::GA,
            "GM" => CountryCode::GM,
            "GE" => CountryCode::GE,
            "DE" => CountryCode::DE,
            "GH" => CountryCode::GH,
            "GI" => CountryCode::GI,
            "GR" => CountryCode::GR,
            "GL" => CountryCode::GL,
            "GD" => CountryCode::GD,
            "GP" => CountryCode::GP,
            "GU" => CountryCode::GU,
            "GT" => CountryCode::GT,
            "GG" => CountryCode::GG,
            "GN" => CountryCode::GN,
            "GW" => CountryCode::GW,
            "GY" => CountryCode::GY,
            "HT" => CountryCode::HT,
            "HM" => CountryCode::HM,
            "VA" => CountryCode::VA,
            "HN" => CountryCode::HN,
            "HK" => CountryCode::HK,
            "HU" => CountryCode::HU,
            "IS" => CountryCode::IS,
            "IN" => CountryCode::IN,
            "ID" => CountryCode::ID,
            "IR" => CountryCode::IR,
            "IQ" => CountryCode::IQ,
            "IE" => CountryCode::IE,
            "IM" => CountryCode::IM,
            "IL" => CountryCode::IL,
            "IT" => CountryCode::IT,
            "JM" => CountryCode::JM,
            "JP" => CountryCode::JP,
            "JE" => CountryCode::JE,
            "JO" => CountryCode::JO,
            "KZ" => CountryCode::KZ,
            "KE" => CountryCode::KE,
            "KI" => CountryCode::KI,
            "KP" => CountryCode::KP,
            "KR" => CountryCode::KR,
            "KW" => CountryCode::KW,
            "KG" => CountryCode::KG,
            "LA" => CountryCode::LA,
            "LV" => CountryCode::LV,
            "LB" => CountryCode::LB,
            "LS" => CountryCode::LS,
            "LR" => CountryCode::LR,
            "LY" => CountryCode::LY,
            "LI" => CountryCode::LI,
            "LT" => CountryCode::LT,
            "LU" => CountryCode::LU,
            "MO" => CountryCode::MO,
            "MK" => CountryCode::MK,
            "MG" => CountryCode::MG,
            "MW" => CountryCode::MW,
            "MY" => CountryCode::MY,
            "MV" => CountryCode::MV,
            "ML" => CountryCode::ML,
            "MT" => CountryCode::MT,
            "MH" => CountryCode::MH,
            "MQ" => CountryCode::MQ,
            "MR" => CountryCode::MR,
            "MU" => CountryCode::MU,
            "YT" => CountryCode::YT,
            "MX" => CountryCode::MX,
            "FM" => CountryCode::FM,
            "MD" => CountryCode::MD,
            "MC" => CountryCode::MC,
            "MN" => CountryCode::MN,
            "ME" => CountryCode::ME,
            "MS" => CountryCode::MS,
            "MA" => CountryCode::MA,
            "MZ" => CountryCode::MZ,
            "MM" => CountryCode::MM,
            "NA" => CountryCode::NA,
            "NR" => CountryCode::NR,
            "NP" => CountryCode::NP,
            "NL" => CountryCode::NL,
            "NC" => CountryCode::NC,
            "NZ" => CountryCode::NZ,
            "NI" => CountryCode::NI,
            "NE" => CountryCode::NE,
            "NG" => CountryCode::NG,
            "NU" => CountryCode::NU,
            "NF" => CountryCode::NF,
            "MP" => CountryCode::MP,
            "NO" => CountryCode::NO,
            "OM" => CountryCode::OM,
            "PK" => CountryCode::PK,
            "PW" => CountryCode::PW,
            "PS" => CountryCode::PS,
            "PA" => CountryCode::PA,
            "PG" => CountryCode::PG,
            "PY" => CountryCode::PY,
            "PE" => CountryCode::PE,
            "PH" => CountryCode::PH,
            "PN" => CountryCode::PN,
            "PL" => CountryCode::PL,
            "PT" => CountryCode::PT,
            "PR" => CountryCode::PR,
            "QA" => CountryCode::QA,
            "RE" => CountryCode::RE,
            "RO" => CountryCode::RO,
            "RU" => CountryCode::RU,
            "RW" => CountryCode::RW,
            "BL" => CountryCode::BL,
            "SH" => CountryCode::SH,
            "KN" => CountryCode::KN,
            "LC" => CountryCode::LC,
            "MF" => CountryCode::MF,
            "PM" => CountryCode::PM,
            "VC" => CountryCode::VC,
            "WS" => CountryCode::WS,
            "SM" => CountryCode::SM,
            "ST" => CountryCode::ST,
            "SA" => CountryCode::SA,
            "SN" => CountryCode::SN,
            "RS" => CountryCode::RS,
            "SC" => CountryCode::SC,
            "SL" => CountryCode::SL,
            "SG" => CountryCode::SG,
            "SX" => CountryCode::SX,
            "SK" => CountryCode::SK,
            "SI" => CountryCode::SI,
            "SB" => CountryCode::SB,
            "SO" => CountryCode::SO,
            "ZA" => CountryCode::ZA,
            "GS" => CountryCode::GS,
            "SS" => CountryCode::SS,
            "ES" => CountryCode::ES,
            "LK" => CountryCode::LK,
            "SD" => CountryCode::SD,
            "SR" => CountryCode::SR,
            "SJ" => CountryCode::SJ,
            "SZ" => CountryCode::SZ,
            "SE" => CountryCode::SE,
            "CH" => CountryCode::CH,
            "SY" => CountryCode::SY,
            "TW" => CountryCode::TW,
            "TJ" => CountryCode::TJ,
            "TZ" => CountryCode::TZ,
            "TH" => CountryCode::TH,
            "TL" => CountryCode::TL,
            "TG" => CountryCode::TG,
            "TK" => CountryCode::TK,
            "TO" => CountryCode::TO,
            "TT" => CountryCode::TT,
            "TN" => CountryCode::TN,
            "TR" => CountryCode::TR,
            "TM" => CountryCode::TM,
            "TC" => CountryCode::TC,
            "TV" => CountryCode::TV,
            "UG" => CountryCode::UG,
            "UA" => CountryCode::UA,
            "AE" => CountryCode::AE,
            "GB" => CountryCode::GB,
            "US" => CountryCode::US,
            "UM" => CountryCode::UM,
            "UY" => CountryCode::UY,
            "UZ" => CountryCode::UZ,
            "VU" => CountryCode::VU,
            "VE" => CountryCode::VE,
            "VN" => CountryCode::VN,
            "VG" => CountryCode::VG,
            "VI" => CountryCode::VI,
            "WF" => CountryCode::WF,
            "EH" => CountryCode::EH,
            "YE" => CountryCode::YE,
            "ZM" => CountryCode::ZM,
            "ZW" => CountryCode::ZW,
            _ => CountryCode::Unknown,
        }
    }
}
